local mod = UpgradeList:NewModule("UI")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

local UPGRADELIST_VERSION = GetAddOnMetadata('UpgradeList', 'Version')

--[[
-------------------------------------------------------------------------------------------------------------------------------------------
                                                 VARIABLE NAMES CREATED IN UI.LUA

DUNGEON JOURNAL
	self.db.UI.InstanceID
	self.db.UI.BossID
	self.db.UI.RaidID
	self.db.UI.RaidBossID
	
MAIN FRAME
	self.db.UI.MainFrame
		.title
		.version
		.TableContainer
		.tabs[#]
	
CLOSE BUTTON
	self.db.UI.CloseButton
	
TOGGLE OPTIONS
	self.db.UI.ToggleButton
	
PRIMARY SPEC VIEW BUTTON
	self.db.UI.ViewPrimaryCheck
	
SECONDARY SPEC VIEW BUTTON
	self.db.UI.ViewSecondaryCheck
	
EXPLANATION HEADING TEXT
	self.db.UI.ExplanationHeading
		.font
									
OPTIONS FRAME
	self.db.UI.OptionsFrame
	
ITEM ENTRY BOX
	self.db.UI.ItemEntryBox
		.indicator
				.texture
		.heading
				.font
				
DROPDOWN MENU
	ULLocationDropDown_Button
	self.db.UI.DropDownHeading
		.font

NOTE ENTRY BOX
	self.db.UI.NoteEntryBox
		.heading
			.font

SPEC RADIO BUTTONS
	self.db.UI.PrimarySpecRadioButton
	self.db.UI.SecondarySpecRadioButton

PRIORITY FIELD
	self.db.UI.PriorityField
		.heading
			.font

ADD ITEM BUTTON
	self.db.UI.AddButton

MOVE ITEM
	self.db.UI.Moving
		.font
		.fromfield
		.tofield
		.to
			.font
		.button

DELETING SINGLE ITEM
	self.db.UI.DeletingSingle
		.font
		.button
		.field

DELETING MULTIPLE ITEMS
	self.db.UI.DeletingMultiple
		.font
		.multifromfield
		.multitofield
		.multithrough
			.font
		.button

STATUS BAR
	self.db.UI.StatusBar
		.font

ITEM TRACK BUTTON
	self.db.UI.ItemTrackButton

POINT INPUT FRAME
	self.db.UI.PointInput
		.heading
			.font
		.box
		.OK
		.Cancel

WEAPON INPUT FRAME
	self.db.UI.WeaponInput
		.heading
			.font
		.MainHandCheck
		.OffHandCheck
		.OK
		.Cancel

SPEC INPUT FRAME
	self.db.UI.SpecInput
		.heading
			.font
		.MainSpecCheck
		.OffSpecCheck
		.OK
		.Cancel

MAIN HAND OR OFF HAND FRAME
	self.db.UI.MainHandorOffHand
		.heading
			.font
		.WeaponInMain
		.WeaponInOff
		.OK
		.Cancel

EDIT NOTE FRAME
	self.db.UI.EditNote
		.heading
			.font
		.box
		.OK
		.Cancel
		
TRACK FRAME
	self.db.UI.TrackFrame
		.title
			.text
		.CloseButton
		.CheckBoxHeading
		.ButtonName
			[name]

-------------------------------------------------------------------------------------------------------------------------------------------
--]]

function UpgradeList:DisableInput()
	self.db.UI.MainFrame:EnableMouse(false)
	self.db.UI.CloseButton:EnableMouse(false)
	self.db.UI.ToggleButton:EnableMouse(false)
	self.db.UI.ViewPrimaryCheck:EnableMouse(false)
	self.db.UI.ViewSecondaryCheck:EnableMouse(false)
	self.db.UI.OptionsFrame:EnableMouse(false)
	self.db.UI.ItemEntryBox:EnableMouse(false)
	ULLocationDropDown_Button:EnableMouse(false)
	self.db.UI.NoteEntryBox:EnableMouse(false)
	self.db.UI.PrimarySpecRadioButton:EnableMouse(false)
	self.db.UI.SecondarySpecRadioButton:EnableMouse(false)
	self.db.UI.PriorityField:EnableMouse(false)
	self.db.UI.AddButton:EnableMouse(false)
	self.db.UI.Moving.tofield:EnableMouse(false)
	self.db.UI.Moving.fromfield:EnableMouse(false)
	self.db.UI.Moving.button:EnableMouse(false)
	self.db.UI.DeletingSingle.button:EnableMouse(false)
	self.db.UI.DeletingSingle.field:EnableMouse(false)
	self.db.UI.DeletingMultiple.multifromfield:EnableMouse(false)
	self.db.UI.DeletingMultiple.multitofield:EnableMouse(false)
	self.db.UI.DeletingMultiple.button:EnableMouse(false)
end

function UpgradeList:EnableInput()
	self.db.UI.MainFrame:EnableMouse(true)
	self.db.UI.CloseButton:EnableMouse(true)
	self.db.UI.ToggleButton:EnableMouse(true)
	self.db.UI.ViewPrimaryCheck:EnableMouse(true)
	self.db.UI.ViewSecondaryCheck:EnableMouse(true)
	self.db.UI.OptionsFrame:EnableMouse(true)
	self.db.UI.ItemEntryBox:EnableMouse(true)
	ULLocationDropDown_Button:EnableMouse(true)
	self.db.UI.NoteEntryBox:EnableMouse(true)
	self.db.UI.PrimarySpecRadioButton:EnableMouse(true)
	self.db.UI.SecondarySpecRadioButton:EnableMouse(true)
	self.db.UI.PriorityField:EnableMouse(true)
	self.db.UI.AddButton:EnableMouse(true)
	self.db.UI.Moving.tofield:EnableMouse(true)
	self.db.UI.Moving.fromfield:EnableMouse(true)
	self.db.UI.Moving.button:EnableMouse(true)
	self.db.UI.DeletingSingle.button:EnableMouse(true)
	self.db.UI.DeletingSingle.field:EnableMouse(true)
	self.db.UI.DeletingMultiple.multifromfield:EnableMouse(true)
	self.db.UI.DeletingMultiple.multitofield:EnableMouse(true)
	self.db.UI.DeletingMultiple.button:EnableMouse(true)
end

function UpgradeList:StatusBarUpdate(message, color)
	if color == "red" then
		self.db.UI.StatusBar.font:SetTextColor(1, 0, 0)
	elseif color == "green" then
		self.db.UI.StatusBar.font:SetTextColor(0, 1, 0)
	else
		self.db.UI.StatusBar.font:SetTextColor(1, 1, 1)
	end
	self.db.UI.StatusBar.font:SetText(message)
end

function UpgradeList:ChatFrameMessage(message)
	DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List:|r " .. message)
end

function UpgradeList:ScrollingWindowMessage(message)
	self.db.profile.messages.scrollwindow:AddMessage(message)
end

function UpgradeList:UpdateIcon(icon)
	if icon == true then
		self.db.UI.ItemEntryBox.indicator.texture:SetTexture("Interface\\RAIDFRAME\\ReadyCheck-Ready.blp")
	else
		self.db.UI.ItemEntryBox.indicator.texture:SetTexture("Interface\\RAIDFRAME\\ReadyCheck-NotReady.blp")
	end
end

function UpgradeList:TabMaker(tabNum, xOffset, yOffset, resizeX, resizeY)
	local tab = CreateFrame('Button', "$parentTab" .. tabNum, self.db.UI.MainFrame, "CharacterFrameTabButtonTemplate")
	tab:SetID(tabNum)
	tab:SetText(self.db.Constants.TabNames[tabNum][3])
	tab:SetPoint("TOP", self.db.UI.MainFrame, "BOTTOM", xOffset, yOffset)
	PanelTemplates_TabResize(tab, 0, resizeX, resizeY)
	tab:RegisterForClicks("AnyUp")
	tab:SetScript("OnClick", function (self, button, down)
		self:SetID(self:GetID())
		PanelTemplates_Tab_OnClick(tab, UpgradeList.db.UI.MainFrame)
		UpgradeList:RefreshWindow()
	end)
	return tab
end

function UpgradeList:LoadDungeonJournalInfo()
	self.db.UI.InstanceID = {}
	self.db.UI.BossID = {}
	self.db.UI.RaidID = {}
	self.db.UI.RaidBossID = {}
	local instanceCount = 1
	local bossCount = 1
	EJ_SetDifficulty(4)
	repeat
		local instanceID, name = EJ_GetInstanceByIndex(instanceCount, false)
		self.db.UI.InstanceID[instanceID] = name
		EJ_SelectInstance(instanceID)
		bossCount = 1
		repeat
			local bossName, _, bossID = EJ_GetEncounterInfoByIndex(bossCount)
			self.db.UI.BossID[bossID] = bossName
			bossCount = bossCount + 1
		until EJ_GetEncounterInfoByIndex(bossCount) == nil
		instanceCount = instanceCount + 1
	until EJ_GetInstanceByIndex(instanceCount, false) == nil
	instanceCount = 1
	repeat
		local raidID, name = EJ_GetInstanceByIndex(instanceCount, true)
		self.db.UI.RaidID[raidID] = name
		EJ_SelectInstance(raidID)
		bossCount = 1
		repeat
			local bossName, _, raidBossID = EJ_GetEncounterInfoByIndex(bossCount)
			self.db.UI.RaidBossID[raidBossID] = bossName
			bossCount = bossCount + 1
		until EJ_GetEncounterInfoByIndex(bossCount) == nil
		instanceCount = instanceCount + 1
	until EJ_GetInstanceByIndex(instanceCount, true) == nil
	EJ_SetDifficulty(1)
end

function UpgradeList:DetermineDifficulty(mask, instanceID)
	local mask = tostring(mask)
	local instanceID = tostring(instanceID)
	if (instanceID == "63" or instanceID == "64" or instanceID == "76" or instanceID == "77" or instanceID == "184" or instanceID == "185" or instanceID == "186") and mask == "1" then mask = "2" end --fixes problem with Encounter Journal saying there's a normal mode or heroic mode only dungeons
	if tostring(mask) == "1" or tostring(mask) == "4" then
		return "Normal"
	elseif tostring(mask) == "2" or tostring(mask) == "3" then
		return "Heroic"
	elseif tostring(mask) == "5" then
		return "LFR"
	else
		print("Upgrade List: Unknown Difficulty Mask")
		return "?"
	end
end

function UpgradeList:CreateScrollingWindow()
	local frame = CreateFrame("ScrollingMessageFrame", "Scrolling Window", UIParent, "ChatFrameTemplate")
	frame:SetPoint("CENTER", 0, 200)
	frame:SetWidth(UIParent:GetWidth() - 200)
	frame:SetHeight(50)
	frame:SetFadeDuration(2)
	frame:SetFading(true)
	frame:SetHyperlinksEnabled(true)
	frame:SetInsertMode("top")
	frame:SetMaxLines(5)
	frame:SetTimeVisible(10)
	frame:SetJustifyH("CENTER")
	frame:SetJustifyV("CENTER")
	frame:SetFontObject(GameFontNormalHuge)
	frame:SetTextColor(1, 1, 1) --white
	frame:EnableMouse(false)
	frame:Show()
	
	self.db.profile.messages.scrollwindow = frame
end

function UpgradeList:CreateMainFrame()
	local frame = CreateFrame("Frame","frame",UIParent)
	frame:SetFrameStrata("DIALOG")
	frame:SetWidth(1257)
	frame:SetHeight(280)
	frame:SetScale(self.db.profile.mainframe.scale)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("TOP",0,-80)

	--Makes the Main Frame (and therefore all frames attached to it) draggable
	if self.db.profile.mainframe.lock == false then
		frame:SetMovable(true)
		frame:EnableMouse(true)
	end
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
	tinsert(UISpecialFrames,"frame")

	--Make a title section for the Main Frame 
	frame.title = frame:CreateTexture(nil,"ARTWORK")
	frame.title:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
	frame.title:SetWidth(280)
	frame.title:SetHeight(64)
	frame.title:SetPoint("TOP", frame, 0, 12)

	frame.title.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	frame.title.text:SetText('Upgrade List')
	frame.title.text:SetPoint("TOP", frame, 0, -3)
	
	--Version Identification
	frame.version = CreateFrame('Frame', "VersionHeading", frame)
	frame.version.font = frame.version:CreateFontString("VersionHeading", "ARTWORK", "GameFontWhiteTiny")
	frame.version.font:SetText("v " .. UPGRADELIST_VERSION)
	frame.version.font:SetPoint("TOPLEFT", frame, "TOPLEFT", 13, -11)
	frame.version.font:SetWidth(frame.version.font:GetStringWidth() + 5)
	frame.version.font:SetHeight(frame.version.font:GetStringHeight())
	
	--Make an invisible frame within the Main Frame that will contain the self.db.char.SavedOptions.tableUL
	frame.TableContainer = CreateFrame("Frame", "TableContainer", frame)
	frame.TableContainer:SetWidth(1265)
	frame.TableContainer:SetHeight(235)
	frame.TableContainer:SetPoint("TOPLEFT", frame, "TOPLEFT", 0, -30)
	frame.TableContainer:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", 0, -12)
	
	self.db.UI.MainFrame = frame
end

function UpgradeList:CreateScrollingItemFrame()
	local cols = {
		{  -- col 1
			name	= L["Priority"],
			width	= 42,
			defaultsort = "asc",
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 2
			name	= _G["ITEM_LEVEL_ABBR"],
			width	= 35,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 3
			name	= _G["ENCOUNTER_JOURNAL_ITEM"],
			width	= 240,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 4
			name	= L["Difficulty"],
			width	= 80,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 5
			name	= "Instance/Rep./Pt. Type/Token",
			width	= 250,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 6
			name	= "Boss/Rep. Level/Pts. Needed/Token Loc.",
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
		{  -- col 7
			name	= _G["LABEL_NOTE"],
			width	= 280,
			align = "CENTER",
			bgcolor = {
				["r"] = 0.0, 
				["g"] = 0.0, 
				["b"] = 0.0, 
				["a"] = 1.0, 
			},
		},
	}

	local rows = 14
	local height = 15
	local UpgradeListScrollingTable = LibStub("ScrollingTable")
	self.db.char.SavedOptions.tableUL = UpgradeListScrollingTable:CreateST(cols, rows, height, nil, self.db.UI.MainFrame.TableContainer) --self.db.char.SavedOptions.tableUL
	self.db.char.SavedOptions.tableUL.frame:SetPoint("CENTER", self.db.UI.MainFrame.TableContainer, "CENTER", 0, 0)
	self.db.char.SavedOptions.tableUL:RegisterEvents({
		["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, UpgradeListScrollingTable, ...)
			ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
			if row ~= nil then --if the user isn't clicking in the column header area
				local ShownSpec
				local ShownSpecLong
				if self.db.UI.ViewPrimaryCheck:GetChecked() then
					ShownSpec = _G["PRIMARY"]
					ShownSpecLong = "PrimarySpecList"
				else
					ShownSpec = _G["SECONDARY"]
					ShownSpecLong = "SecondarySpecList"
				end
				for i = 1, #self.db.Constants.TabNames, 1 do
					if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == self.db.Constants.TabNames[i][1] then
						if IsModifiedClick("CTRL") then
							UpgradeList.db.UI.EditNote.box:SetText(UpgradeList.db.char[ShownSpecLong][UpgradeList.db.Constants.TabNames[i][2]].Row[realrow][7])
							UpgradeList.db.UI.EditNote.box:HighlightText()
							UpgradeList.db.UI.EditNote:Show()
							UpgradeList:DisableInput()
							EditNoteOK:SetScript("OnClick", function (self, button, down)
								local newnote = EditNoteBox:GetText()
								UpgradeList.db.UI.EditNote:Hide()
								UpgradeList.db.UI.EditNote.box:SetText("")
								UpgradeList.db.char[ShownSpecLong][UpgradeList.db.Constants.TabNames[i][2]].Row[realrow][7] = newnote
								UpgradeList:EnableInput()
								UpgradeList:RefreshWindow()
							end)
						elseif IsModifiedClick("SHIFT") then
							ChatEdit_InsertLink(self.db.char[ShownSpecLong][self.db.Constants.TabNames[i][2]].Row[realrow][3])
						else
							ItemRefTooltip:SetHyperlink(self.db.char[ShownSpecLong][self.db.Constants.TabNames[i][2]].Row[realrow][3])
						end
					end
				end
			end
			ShowUIPanel(ItemRefTooltip)
		end,
	})
end

function UpgradeList:CloseButton()
	local CloseButton = CreateFrame('Button', "CloseButton", self.db.UI.MainFrame, "UIPanelCloseButton")
	CloseButton:SetPoint("TOPRIGHT", -1, -2)
	CloseButton:SetWidth(40)
	CloseButton:SetHeight(40)
	
	self.db.UI.CloseButton = CloseButton
end

function UpgradeList:ToggleOptionsButton()
	local ToggleButton = CreateFrame('Button', "ToggleButton", self.db.UI.MainFrame, "UIPanelButtonTemplate2")
	ToggleButton:SetPoint("RIGHT", self.db.UI.CloseButton, "LEFT", 8, 0)
	ToggleButton:SetWidth(170)
	ToggleButton:SetHeight(20)
	ToggleButton:SetText(L["Toggle Options Window"])
	ToggleButton:SetScript("OnClick", function (self, button, down)
		UpgradeList:ToggleOptions()
	end)
	
	self.db.UI.ToggleButton = ToggleButton
end

function UpgradeList:PrimarySpecViewButton()
	local button = CreateFrame('CheckButton', "ViewPrimaryCheckButton", self.db.UI.MainFrame, "UICheckButtonTemplate")
	button:SetPoint("RIGHT", self.db.UI.ToggleButton, "LEFT", -275, -2)
	button:SetChecked(true)
	_G[button:GetName() .. "Text"]:SetText(L["View Primary Spec"])
	button:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			UpgradeList.db.UI.ViewSecondaryCheck:Disable()
			UpgradeList.db.UI.ViewPrimaryCheck:SetChecked(true)
		else
			UpgradeList.db.UI.ViewSecondaryCheck:SetChecked(false)
			UpgradeList:RefreshWindow()
		end
	UpgradeList.db.UI.ViewPrimaryCheck:SetChecked(true)
	end)
	
	self.db.UI.ViewPrimaryCheck = button
end

function UpgradeList:SecondarySpecViewButton()
	local button = CreateFrame('CheckButton', "ViewSecondaryCheckButton", self.db.UI.MainFrame, "UICheckButtonTemplate")
	button:SetPoint("RIGHT", self.db.UI.ToggleButton, "LEFT", -125, -2)
	button:SetChecked(false)
	_G[button:GetName() .. "Text"]:SetText(L["View Secondary Spec"])
	if GetNumTalentGroups("player") == 1 then
		_G[button:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5)
		button:Disable()
	end
	button:SetScript("OnClick", function (self, button, down)
		UpgradeList.db.UI.ViewSecondaryCheck:SetChecked(true)
		UpgradeList.db.UI.ViewPrimaryCheck:SetChecked(false)
		UpgradeList:RefreshWindow()
	end)
	
	self.db.UI.ViewSecondaryCheck = button
end

function UpgradeList:ExplanationHeadingText()
	local text = CreateFrame('Frame', "text", self.db.UI.MainFrame)
	text.font = text:CreateFontString("textfont", "ARTWORK", "GameFontWhiteTiny")
	text.font:SetText(L["Clicking a row will show the tooltip for the item, Shift-clicking a row will allow you to add the item link into your chat window, Ctrl-clicking a row will allow you to edit the note for that row."])
	text.font:SetPoint("TOPLEFT", self.db.UI.MainFrame, "TOPLEFT", 55, -11)
	text.font:SetPoint("BOTTOMRIGHT", self.db.UI.MainFrame, "TOPRIGHT", -710, -30)
	text.font:SetHeight(text.font:GetStringHeight())
	text.font:SetJustifyH("LEFT")
	
	self.db.UI.ExplanationHeading = text
end

function UpgradeList:TabCreate()
	PanelTemplates_SetNumTabs(self.db.UI.MainFrame, 16)
	self.db.UI.MainFrame.tabs = {}
	for i = 1, #self.db.Constants.TabNames, 1 do
		self.db.UI.MainFrame.tabs[i] = UpgradeList:TabMaker(i, self.db.Constants.TabNames[i][4], self.db.Constants.TabNames[i][5], self.db.Constants.TabNames[i][6], self.db.Constants.TabNames[i][7])
	end
	PanelTemplates_SetTab(self.db.UI.MainFrame, 1)
	UpgradeList:RefreshWindow()
end

function UpgradeList:CreateOptionsFrame()
	local frame = CreateFrame("Frame", "frame", self.db.UI.MainFrame)
	frame:SetWidth(850)
	frame:SetHeight(330)
	frame:SetPoint("TOP",self.db.UI.MainFrame,"BOTTOM", 0, -30)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 12, top = 12, bottom = 11 }})

	self.db.UI.OptionsFrame = frame
end

function UpgradeList:CreateItemEntryBox()
	local frame = CreateFrame('EditBox', "ItemEntryBox", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame:SetPoint("CENTER", 0, 125)
	frame:SetAutoFocus(false)
	frame:SetWidth(130)
    frame:SetHeight(24)
	frame:SetScript("OnTextChanged", function (self, userInput)
		if userInput then
			UpgradeList:CancelAllTimers()
			UpgradeList:UpdateIcon(false)
			if GetItemInfo(frame:GetText()) == nil then
				UpgradeList:ScheduleRepeatingTimer("ValidateItem", 0.5) --keeps checking for new items loaded into cache
			else --item exists, now have to check if it's in EJ
				local itemName, itemLink = GetItemInfo(frame:GetText()) 
				local _, _, _, _, itemID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				UpgradeList:CancelAllTimers()
				EJ_SetSearch(itemName)
				if EJ_GetNumSearchResults() == 0 then --no match in dungeon journal
					UpgradeList:UpdateIcon(false)
					UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
				else
					for i = 1, EJ_GetNumSearchResults(), 1 do
						local EJID, _, EJDifficulty, EJInstanceID, EJEncounterID = EJ_GetSearchResult(i)
						local _, _, _, _, EJItemID = EJ_GetLootInfo(EJID)
						if tostring(EJItemID) == tostring(itemID) then --match found
							UpgradeList:UpdateIcon(true) --catches items already in cache
							UpgradeList.db.SelectedInstance = UpgradeList.db.UI.InstanceID[EJInstanceID] or UpgradeList.db.UI.RaidID[EJInstanceID]
							UpgradeList.db.SelectedBoss = UpgradeList.db.UI.BossID[EJEncounterID] or UpgradeList.db.UI.RaidBossID[EJEncounterID]
							UpgradeList.db.SelectedDifficulty = UpgradeList:DetermineDifficulty(EJDifficulty, EJInstanceID)
							UIDropDownMenu_SetText(ULLocationDropDown_Button, L["Location Auto-Set!"])
							break
						end
					end
				end
			end
		end
	end)
	frame:SetScript("OnHide", function(self)
		UpgradeList:CancelAllTimers()
	end)
	
	frame.indicator = CreateFrame('Frame', "AutoItemIndicator", self.db.UI.OptionsFrame)
	frame.indicator:SetHeight(frame:GetHeight() - 5)
	frame.indicator:SetWidth(frame.indicator:GetHeight())
	frame.indicator:SetPoint("LEFT", frame, "RIGHT", 5, 0)
	frame.indicator.texture = frame.indicator:CreateTexture("AutoTexture", "HIGH")
	frame.indicator.texture:SetAllPoints(frame.indicator)
	frame.indicator.texture:SetTexture("Interface\\RAIDFRAME\\ReadyCheck-NotReady.blp")
	
	frame.heading = CreateFrame('Frame', "ItemEntryBoxHeading", self.db.UI.OptionsFrame)
	frame.heading.font = frame.heading:CreateFontString("ItemHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.heading.font:SetText("Enter item link or item ID:")
	frame.heading.font:SetPoint("BOTTOM", frame, "TOP", 3, 0)
	frame.heading.font:SetWidth(frame.heading.font:GetStringWidth() + 10)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())	
	
	self.db.UI.ItemEntryBox = frame
end

function UpgradeList:CreateDropdownMenu()
	CreateFrame("Button", "ULLocationDropDown_Button", self.db.UI.OptionsFrame, "UIDropDownMenuTemplate")
	ULLocationDropDown_Button:ClearAllPoints()
	ULLocationDropDown_Button:SetPoint("TOP", self.db.UI.ItemEntryBox, "BOTTOM", 0, -20)
	ULLocationDropDown_Button:Show()
	
	local path = {}

	--value is what is under your mouse
	--path is the value 1 level behind your mouse
	
	local function HandleDropdownSelection(info, level, value)
		if level == 1 then --Top Level
			for i = 1, #self.db.Constants.GeneralItemLocations do
				info = UIDropDownMenu_CreateInfo()
				info.text = self.db.Constants.GeneralItemLocations[i][1]
				info.notCheckable = 1
				if info.text == self.db.Constants.GeneralItemLocations[8][1] then --"Other" items
					info.func = function()
						UIDropDownMenu_SetText(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[8][1])
						self.db.SelectedBoss = ""
						self.db.SelectedInstance = self.db.Constants.GeneralItemLocations[8][1]
						self.db.SelectedDifficulty = ""
						CloseDropDownMenus(1)
					end
					info.hasArrow = false
					UIDropDownMenu_AddButton(info, level)
				else
					info.hasArrow = true
					info.value = self.db.Constants.GeneralItemLocations[i][1]
					path[level - 1] = value
					UIDropDownMenu_AddButton(info, level)
				end
			end
		elseif level == 2 then
			for i = 1, #self.db.Constants.GeneralItemLocations - 1 do --Takes off "Other"
				if value == self.db.Constants.GeneralItemLocations[i][1] and self.db.Constants.GeneralItemLocations[i][2] ~= nil and self.db.Constants.GeneralItemLocations[i][3] ~= nil then --Raids, Dungeons, Reputation Rewards, & Purchasable items
					if value == self.db.Constants.GeneralItemLocations[6][1] then --Purchasable menu
						for j = 1, #self.db.Constants.GeneralItemLocations[6][2] do
							if j == 1 then --Gear Tokens in Purchasable menu
								info.text = self.db.Constants.GeneralItemLocations[6][2][j]
								info.hasArrow = true
								info.value = self.db.Constants.GeneralItemLocations[6][2][j]
								path[level - 1] = value
								info.notCheckable = 1
								UIDropDownMenu_AddButton(info, level)
							else --Everything else in Purchasable menu
								info.text = self.db.Constants.GeneralItemLocations[6][2][j]
								info.hasArrow = false
								info.value = self.db.Constants.GeneralItemLocations[6][2][j]
								path[level - 1] = value
								info.notCheckable = 1
								info.func = function()
									CloseDropDownMenus(1)
									UIDropDownMenu_SetSelectedName(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[6][2][j])
									self.db.UI.PointInput:Show()
									UpgradeList:DisableInput()
								end
								UIDropDownMenu_AddButton(info, level)
							end
						end
					else --Everything except Purchasable menu
						for j = 1, #self.db.Constants.GeneralItemLocations[i][2] do
							info.text = self.db.Constants.GeneralItemLocations[i][2][j]
							info.hasArrow = true
							info.value = self.db.Constants.GeneralItemLocations[i][2][j]
							path[level - 1] = value
							info.notCheckable = 1
							UIDropDownMenu_AddButton(info, level)
						end
					end
				elseif value == self.db.Constants.GeneralItemLocations[i][1] and self.db.Constants.GeneralItemLocations[i][2] ~= nil and self.db.Constants.GeneralItemLocations[i][3] == nil then --Crafted items
					for j = 1, #self.db.Constants.GeneralItemLocations[i][2] do
						info.text = self.db.Constants.GeneralItemLocations[i][2][j]
						info.hasArrow = false
						info.value = self.db.Constants.GeneralItemLocations[i][2][j]
						path[level - 1] = value
						info.notCheckable = 1
						info.func = function()
							UIDropDownMenu_SetText(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[i][2][j])
							self.db.SelectedBoss = ""
							self.db.SelectedInstance = self.db.Constants.GeneralItemLocations[i][2][j]
							self.db.SelectedDifficulty = ""
							CloseDropDownMenus(1)
						end
						UIDropDownMenu_AddButton(info, level)
					end
				elseif value == self.db.Constants.GeneralItemLocations[i][1] and self.db.Constants.GeneralItemLocations[i][2] == nil then --Quest Reward & World Drop items
					info.text = self.db.Constants.GeneralItemLocations[i][1]
					info.hasArrow = false
					info.value = self.db.Constants.GeneralItemLocations[i][1]
					info.notCheckable = 1
					info.func = function()
						UIDropDownMenu_SetText(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[i][1])
						self.db.SelectedBoss = ""
						self.db.SelectedInstance = self.db.Constants.GeneralItemLocations[i][1]
						self.db.SelectedDifficulty = ""
						CloseDropDownMenus(1)
					end
					UIDropDownMenu_AddButton(info, level)
				end
			end
		elseif level == 3 then
			for i = 1, #self.db.Constants.GeneralItemLocations - 1 do --for each general category
				if self.db.Constants.GeneralItemLocations[i][3] ~= nil then --if the category has a 3rd argument
					for j = 1, #self.db.Constants.GeneralItemLocations[i][3] do --for each entry in a category's 3rd argument
						if i == 1 then --Raid
							if value == self.db.Constants.GeneralItemLocations[i][2][1] and path[1] == self.db.Constants.GeneralItemLocations[i][1] then --Raid
								if self.db.Constants.GeneralItemLocations[i][3][j][1] == 1 and self.db.Constants.GeneralItemLocations[i][3][j][2] ~= 75 then --Heroic, takes Baradin Hold out
									info.text = self.db.Constants.GeneralItemLocations[i][3][j][3]
									info.hasArrow = true
									info.value = self.db.Constants.GeneralItemLocations[i][3][j][3]
									path[level - 1] = value
									info.notCheckable = 1
									UIDropDownMenu_AddButton(info, level)
								end
							elseif value == self.db.Constants.GeneralItemLocations[i][2][2] and path[1] == self.db.Constants.GeneralItemLocations[i][1] then --Normal
								if self.db.Constants.GeneralItemLocations[i][3][j][1] == 1 then
									info.text = self.db.Constants.GeneralItemLocations[i][3][j][3]
									info.hasArrow = true
									info.value = self.db.Constants.GeneralItemLocations[i][3][j][3]
									path[level - 1] = value
									info.notCheckable = 1
									UIDropDownMenu_AddButton(info, level)
								end
							elseif value == self.db.Constants.GeneralItemLocations[i][2][3] and path[1] == self.db.Constants.GeneralItemLocations[i][1] then --LFR
								if self.db.Constants.GeneralItemLocations[i][3][j][1] == 1 and self.db.Constants.GeneralItemLocations[i][3][j][5] == true then
									info.text = self.db.Constants.GeneralItemLocations[i][3][j][3]
									info.hasArrow = true
									info.value = self.db.Constants.GeneralItemLocations[i][3][j][3]
									path[level - 1] = value
									info.notCheckable = 1
									UIDropDownMenu_AddButton(info, level)
								end
							end
						elseif i == 2 then --Dungeon
							if value == self.db.Constants.GeneralItemLocations[i][2][1] and path[1] == self.db.Constants.GeneralItemLocations[i][1] then --Heroic
								if self.db.Constants.GeneralItemLocations[i][3][j][1] == 2 then
									info.text = self.db.Constants.GeneralItemLocations[i][3][j][3]
									info.hasArrow = true
									info.value = self.db.Constants.GeneralItemLocations[i][3][j][3]
									path[level - 1] = value
									info.notCheckable = 1
									UIDropDownMenu_AddButton(info, level)
								end
							elseif path[1] == self.db.Constants.GeneralItemLocations[i][1] then --Normal
								if self.db.Constants.GeneralItemLocations[i][3][j][1] == 2 and self.db.Constants.GeneralItemLocations[i][3][j][5] == true then
									info.text = self.db.Constants.GeneralItemLocations[i][3][j][3]
									info.hasArrow = true
									info.value = self.db.Constants.GeneralItemLocations[i][3][j][3]
									path[level - 1] = value
									info.notCheckable = 1
									UIDropDownMenu_AddButton(info, level)
								end
							end
						elseif i == 5 then --Reputation Reward
							for k = 1, #self.db.Constants.GeneralItemLocations[i][2] do
								if value == self.db.Constants.GeneralItemLocations[i][2][k] then
									info.text = self.db.Constants.GeneralItemLocations[i][3][j]
									info.hasArrow = false
									info.value = self.db.Constants.GeneralItemLocations[i][3][j]
									path[level - 1] = value
									info.notCheckable = 1
									info.func = function()
										UIDropDownMenu_SetText(ULLocationDropDown_Button, path[2])
										self.db.SelectedBoss = self.db.Constants.GeneralItemLocations[i][3][j]
										self.db.SelectedInstance =  path[2]
										self.db.SelectedDifficulty = ""
										CloseDropDownMenus(1)
									end
									UIDropDownMenu_AddButton(info, level)
								end
							end
						elseif i == 6 then --Purchasable items
							if value == self.db.Constants.GeneralItemLocations[i][2][1] then
								info.text = self.db.Constants.GeneralItemLocations[i][3][j]
								info.hasArrow = true
								info.value = self.db.Constants.GeneralItemLocations[i][3][j]
								path[level - 1] = value
								info.notCheckable = 1
								UIDropDownMenu_AddButton(info, level)
							end
						end
					end
				end
			end
		elseif level == 4 then
			for i = 1, #self.db.Constants.GeneralItemLocations - 1 do --for each general category
				if self.db.Constants.GeneralItemLocations[i][4] ~= nil then --if the category has a 4th argument
					for j = 1, #self.db.Constants.GeneralItemLocations[i][4] do --for each entry in a category's 4th argument
						if path[1] == self.db.Constants.GeneralItemLocations[i][1] and (i == 1 or i == 2) and value == self.db.Constants.GeneralItemLocations[i][3][j][3] then
							for k = 1, #self.db.Constants.GeneralItemLocations[i][4][j][4] do --each boss
								info.text = self.db.Constants.GeneralItemLocations[i][4][j][4][k]
								info.hasArrow = false
								info.value = info.text
								path[level - 1] = value
								info.notCheckable = 1
								info.func = function()
									UIDropDownMenu_SetText(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[i][4][j][4][k])
									self.db.SelectedBoss = self.db.Constants.GeneralItemLocations[i][4][j][4][k]
									self.db.SelectedInstance = path[3]
									self.db.SelectedDifficulty = path[2]
									CloseDropDownMenus(1)
								end
								UIDropDownMenu_AddButton(info, level)
							end
							if self.db.Constants.GeneralItemLocations[i][4][j][6] then --instance has trash drops
								info.text = L["(Trash Drop)"]
								info.hasArrow = false
								info.value = info.text
								path[level - 1] = value
								info.notCheckable = 1
								info.func = function()
									UIDropDownMenu_SetText(ULLocationDropDown_Button, "(Trash Drop)")
									self.db.SelectedBoss = "(Trash Drop)"
									self.db.SelectedInstance = path[3]
									self.db.SelectedDifficulty = path[2]
									CloseDropDownMenus(1)
								end
								UIDropDownMenu_AddButton(info, level)
							end
							if self.db.Constants.GeneralItemLocations[i][4][j][7] then --instance has another way of dropping gear (Multi-boss drop, timed event, etc.)
								info.text = "(" .. _G["OTHER"] .. ")"
								info.hasArrow = false
								info.value = info.text
								path[level - 1] = value
								info.notCheckable = 1
								info.func = function()
									UIDropDownMenu_SetText(ULLocationDropDown_Button, "(" .. _G["OTHER"] .. ")")
									self.db.SelectedBoss = "(" .. _G["OTHER"] .. ")"
									self.db.SelectedInstance = path[3]
									self.db.SelectedDifficulty = path[2]
									CloseDropDownMenus(1)
								end
								UIDropDownMenu_AddButton(info, level)
							end
						elseif path[1] == self.db.Constants.GeneralItemLocations[i][1] and i == 6 then --Purchasable
							if value == self.db.Constants.GeneralItemLocations[i][3][1] or ((value == self.db.Constants.GeneralItemLocations[i][3][2] or value == self.db.Constants.GeneralItemLocations[i][3][3]) and j ~= 3) then --Takes LFR out of Tier 11 & 12
								info.text = self.db.Constants.GeneralItemLocations[i][4][j]
								info.hasArrow = true
								info.value = self.db.Constants.GeneralItemLocations[i][4][j]
								path[level - 1] = value
								info.notCheckable = 1
								UIDropDownMenu_AddButton(info, level)
							end
						end
					end
				end
			end
		elseif level == 5 then
			for i = 1, #self.db.Constants.GeneralItemLocations - 1 do --for each general category
				if self.db.Constants.GeneralItemLocations[i][5] ~= nil then --if the category has a 5th argument
					for j = 1, #self.db.Constants.GeneralItemLocations[i][5] do --for each entry in a category's 5th argument
						if path[1] == self.db.Constants.GeneralItemLocations[i][1] and i == 6 then
							for k = 1, #self.db.Constants.GeneralItemLocations[6][3] do
								if path[3] == self.db.Constants.GeneralItemLocations[6][3][k] then --seperate each tier, k is what tier is selected
									for l = 1, #self.db.Constants.GeneralItemLocations[6][4] do
										if value == self.db.Constants.GeneralItemLocations[6][4][l] then --seperate each difficulty
											if self.db.Constants.GeneralItemLocations[6][3][k] == self.db.Constants.GeneralItemLocations[6][5][j][5] and self.db.Constants.GeneralItemLocations[6][4][l] == self.db.Constants.GeneralItemLocations[6][5][j][6] then --tier & difficulty match
												info.text = self.db.Constants.GeneralItemLocations[i][5][j][2]
												info.hasArrow = false
												info.value = self.db.Constants.GeneralItemLocations[i][5][j][2]
												path[level - 1] = value
												info.notCheckable = 1
												info.func = function()
													UIDropDownMenu_SetText(ULLocationDropDown_Button, self.db.Constants.GeneralItemLocations[i][5][j][2])
													self.db.SelectedBoss = self.db.Constants.GeneralItemLocations[i][5][j][4]
													self.db.SelectedInstance = self.db.Constants.GeneralItemLocations[i][5][j][3]
													self.db.SelectedDifficulty = self.db.Constants.GeneralItemLocations[i][5][j][6]
													CloseDropDownMenus(1)
												end
												UIDropDownMenu_AddButton(info, level)
											end
										end
									end
								end
							end
						end
					end	
				end
			end
		end
	end
	

	function DropDown_InitializeDropDown(self, level)
		local info = {}
	
		for i = 1, 5 do --1 through 5 are the 5 possible levels of the dropdown menu
			if level == i then
				local info = UIDropDownMenu_CreateInfo()
				HandleDropdownSelection(info, level, UIDROPDOWNMENU_MENU_VALUE)
			end
		end
	end

	function DropDown_DropDownOnLoad(self)
		UIDropDownMenu_Initialize(self, DropDown_InitializeDropDown)
	end

	function ULLocationDropDown_ButtonOnClick(self, button, down)
		local name = self:GetName()
		ToggleDropDownMenu(1, nil, DropDown_DropDown, name, 0, 0)
	end
	
	UIDropDownMenu_Initialize(ULLocationDropDown_Button, DropDown_InitializeDropDown)
	UIDropDownMenu_SetWidth(ULLocationDropDown_Button, 175)
	UIDropDownMenu_SetButtonWidth(ULLocationDropDown_Button, 175)
	UIDropDownMenu_SetSelectedID(ULLocationDropDown_Button, 0)
	UIDropDownMenu_JustifyText(ULLocationDropDown_Button, "CENTER")
	UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])

	local frame = CreateFrame('Frame', "DropDownHeading", self.db.UI.OptionsFrame)
	frame.font = frame:CreateFontString("DropDownHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.font:SetText(L["Select Item Location:"])
	frame.font:SetPoint("BOTTOM", ULLocationDropDown_Button, "TOP", 3, 0)
	frame.font:SetWidth(frame.font:GetStringWidth() + 10)
	frame.font:SetHeight(frame.font:GetStringHeight())	
	
	self.db.UI.DropDownHeading = frame
end

function UpgradeList:CreateNoteEntryBox()
	local frame = CreateFrame('EditBox', "NoteEntryBox", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame:SetPoint("TOP", ULLocationDropDown_Button, "BOTTOM", 0, -20)
	frame:SetAutoFocus(false)
	frame:SetWidth(250)
    frame:SetHeight(24)
	
	frame.heading = CreateFrame('Frame', "NoteEntryBoxHeading", self.db.UI.OptionsFrame)
	frame.heading.font = frame.heading:CreateFontString("NoteHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.heading.font:SetText(L["Enter an optional note:"])
	frame.heading.font:SetPoint("BOTTOM", frame, "TOP", 3, 0)
	frame.heading.font:SetWidth(frame.heading.font:GetStringWidth() + 10)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())	
	
	self.db.UI.NoteEntryBox = frame
end

function UpgradeList:CreateSpecRadioButtons()
	--Primary Spec Selector Radio Button
	local button = CreateFrame('CheckButton', "PrimarySpecRadioButton", self.db.UI.OptionsFrame, "UIRadioButtonTemplate")
	button:SetHeight(20)
	button:SetWidth(20)
	button:SetChecked(true)
	button:SetPoint("TOP", self.db.UI.NoteEntryBox, "BOTTOM", -95, -25)
	_G[button:GetName() .. "Text"]:SetText(L["Primary Spec"])
	button:SetScript("OnClick", function (self, button, down)
		if GetNumTalentGroups("player") == 1 then
			UpgradeList.db.UI.SecondarySpecRadioButton:Disable()
			UpgradeList.db.UI.PrimarySpecRadioButton:SetChecked(true)
		else
			UpgradeList.db.UI.SecondarySpecRadioButton:SetChecked(false)
		end
		UpgradeList.db.UI.PrimarySpecRadioButton:SetChecked(true)
	end)
	
	self.db.UI.PrimarySpecRadioButton = button
	
	--Secondary Spec Selector Radio Button
	local button = CreateFrame('CheckButton', "SecondarySpecRadioButton", self.db.UI.OptionsFrame, "UIRadioButtonTemplate")
	button:SetHeight(20)
	button:SetWidth(20)
	button:SetChecked(false)
	button:SetPoint("TOP", self.db.UI.NoteEntryBox, "BOTTOM", 20, -25)
	_G[button:GetName() .. "Text"]:SetText(L["Secondary Spec"])
	if GetNumTalentGroups("player") == 1 then
		_G[button:GetName() .. "Text"]:SetTextColor(0.5, 0.5, 0.5)
		button:Disable()
	end
	button:SetScript("OnClick", function (self, button, down)
		UpgradeList.db.UI.SecondarySpecRadioButton:SetChecked(true)
		UpgradeList.db.UI.PrimarySpecRadioButton:SetChecked(false)
	end)
	
	self.db.UI.SecondarySpecRadioButton = button
	
	local frame = CreateFrame('Frame', "SpecEntryBoxHeading", self.db.UI.OptionsFrame)
	frame.font = frame:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.font:SetText(L["Select which spec to which you would like to add this item:"])
	frame.font:SetPoint("BOTTOM", self.db.UI.NoteEntryBox, "TOP", 3, -47)
	frame.font:SetWidth(frame.font:GetStringWidth() + 10)
	frame.font:SetHeight(frame.font:GetStringHeight())	
end

function UpgradeList:AddItemLocation()
	local frame = CreateFrame('EditBox', "priorityfield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame:SetPoint("TOP", self.db.UI.ItemEntryBox, "BOTTOM", 0, -180)
	frame:SetAutoFocus(false)
	frame:SetWidth(25)
	frame:SetHeight(24)
	
	frame.heading = CreateFrame('Frame', "PriorityBoxHeading", self.db.UI.OptionsFrame)
	frame.heading.font = frame.heading:CreateFontString("SpecHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.heading.font:SetText(L["Enter the priority number for this item OR \nleave it blank to add the item to bottom of the list:"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("BOTTOM", frame, "TOP", 3, 5)
	frame.heading.font:SetWidth(frame.heading.font:GetStringWidth() + 10)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())	
	
	self.db.UI.PriorityField = frame
end

function UpgradeList:CreateAddButton()
	local button = CreateFrame('Button', "AddButton", self.db.UI.OptionsFrame, "UIPanelButtonTemplate")
	button:SetPoint("TOP", self.db.UI.PriorityField, "BOTTOM", 0, -5)
	button:SetWidth(100)
    button:SetHeight(24)
	button:SetText(L["Add Item"])
	button:SetScript("OnEnter", function (self, motion)
		if UpgradeList.db.UI.ItemEntryBox ~= "" then
			UpgradeList:LoadItemIntoCache(UpgradeList.db.UI.ItemEntryBox)
		end
	end)
	button:SetScript("OnClick", function (self, button, down)
		UpgradeList:AddItem()
	end)
	
	self.db.UI.AddButton = button
end

function UpgradeList:CreateMoveItem()
	--Moving heading text
	local frame = CreateFrame('Frame', "MovingHeading", self.db.UI.OptionsFrame)
	frame.font = frame:CreateFontString("MovingHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.font:SetText("Move item #:")
	frame.font:SetPoint("BOTTOM", self.db.UI.ItemEntryBox, "TOP", -275, 0)
	frame.font:SetWidth(frame.font:GetStringWidth() + 10)
	frame.font:SetHeight(frame.font:GetStringHeight())
	
	--"From" field for moving items
	frame.fromfield = CreateFrame('EditBox', "fromfield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame.fromfield:SetPoint("TOP", frame.font, "BOTTOM", -25, -2)
	frame.fromfield:SetAutoFocus(false)
	frame.fromfield:SetWidth(25)
	frame.fromfield:SetHeight(24)
	
	--"To" field for moving items
	frame.tofield = CreateFrame('EditBox', "tofield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame.tofield:SetPoint("TOP", frame.font, "BOTTOM", 25, -3)
	frame.tofield:SetAutoFocus(false)
	frame.tofield:SetWidth(25)
	frame.tofield:SetHeight(24)
	
	--"To" between the To and From fields
	frame.to = CreateFrame('Frame', "To", self.db.UI.OptionsFrame)
	frame.to.font = frame.to:CreateFontString("to", "ARTWORK", "GameFontNormalSmallLeft")
	frame.to.font:SetText(L["to"])
	frame.to.font:SetPoint("TOP", frame.font, "BOTTOM", -2, -9)
	
	--"Move Item" button
	frame.button = CreateFrame('Button', "MoveButton", self.db.UI.OptionsFrame, "UIPanelButtonTemplate")
	frame.button:SetPoint("TOP", frame.to.font, "BOTTOM", 0, -10)
	frame.button:SetWidth(100)
    frame.button:SetHeight(24)
	frame.button:SetText(L["Move Item"])
	frame.button:SetScript("OnClick", function (self, button, down)
		UpgradeList:MoveItem()
	end)
	
	self.db.UI.Moving = frame
end

function UpgradeList:CreateDeleteSingleItem()
	--"Delete item" heading
	local frame = CreateFrame('Frame', "DeletingHeading", self.db.UI.OptionsFrame)
	frame.font = frame:CreateFontString("DeletingHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.font:SetText("Delete item #:")
	frame.font:SetPoint("BOTTOM", self.db.UI.ItemEntryBox, "TOP", -275, -90)
	frame.font:SetWidth(frame.font:GetStringWidth() + 10)
	frame.font:SetHeight(frame.font:GetStringHeight())
	
	--"Delete Item" button
	frame.button = CreateFrame('Button', "DeleteButton", self.db.UI.OptionsFrame, "UIPanelButtonTemplate")
	frame.button:SetPoint("TOP", frame.font, "BOTTOM", 0, -25)
	frame.button:SetWidth(100)
    frame.button:SetHeight(24)
	frame.button:SetText(L["Delete Item"])
	frame.button:SetScript("OnClick", function (self, button, down)
		UpgradeList:DeleteItem()
	end)
	
	--"Delete Item" field
	frame.field = CreateFrame('EditBox', "deletefield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame.field:SetPoint("TOP", frame.font, "BOTTOM", 0, 0)
	frame.field:SetAutoFocus(false)
	frame.field:SetWidth(25)
	frame.field:SetHeight(24)
	
	self.db.UI.DeletingSingle = frame
end

function UpgradeList:CreateDeleteManyItems()
	--MultiDelete heading text
	local frame = CreateFrame('Frame', "MultiDeleteHeading", self.db.UI.OptionsFrame)
	frame.font = frame:CreateFontString("MultiDeleteHeading", "ARTWORK", "GameFontNormalSmallLeft")
	frame.font:SetText("Delete item #'s:")
	frame.font:SetPoint("BOTTOM", ItemEntryBox, "TOP", -275, -180)
	frame.font:SetWidth(frame.font:GetStringWidth() + 10)
	frame.font:SetHeight(frame.font:GetStringHeight())
	
	--"From" field for MultiDelete items
	frame.multifromfield = CreateFrame('EditBox', "multifromfield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame.multifromfield:SetPoint("TOP", frame.font, "BOTTOM", -38, -2)
	frame.multifromfield:SetAutoFocus(false)
	frame.multifromfield:SetWidth(25)
	frame.multifromfield:SetHeight(24)
	
	--"To" field for MultiDelete items
	frame.multitofield = CreateFrame('EditBox', "multitofield", self.db.UI.OptionsFrame, "InputBoxTemplate")
	frame.multitofield:SetPoint("TOP", frame.font, "BOTTOM", 38, -3)
	frame.multitofield:SetAutoFocus(false)
	frame.multitofield:SetWidth(25)
	frame.multitofield:SetHeight(24)
	
	--"Through" between the To and From fields
	frame.multithrough = CreateFrame('Frame', "multiThrough", self.db.UI.OptionsFrame)
	frame.multithrough.font = frame.multithrough:CreateFontString("multiThrough", "ARTWORK", "GameFontNormalSmallLeft")
	frame.multithrough.font:SetText(L["through"])
	frame.multithrough.font:SetPoint("TOP", frame.font, "BOTTOM", -2, -9)
	
	--"Multi-Delete Item" button
	frame.button = CreateFrame('Button', "MultiDeleteButton", self.db.UI.OptionsFrame, "UIPanelButtonTemplate")
	frame.button:SetPoint("TOP", frame.multithrough.font, "BOTTOM", 0, -10)
	frame.button:SetWidth(100)
    frame.button:SetHeight(24)
	frame.button:SetText(L["Delete Items"])
	frame.button:SetScript("OnClick", function (self, button, down)
		UpgradeList:DeleteSectionOfItems()
	end)
	
	self.db.UI.DeletingMultiple = frame
end

function UpgradeList:CreateStatusBar()
	local PaneBackdrop  = {
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		tile = true, tileSize = 16, edgeSize = 16,
		insets = { left = 3, right = 3, top = 5, bottom = 3 }
	}
	
	local statusbar = CreateFrame("Frame", "Status Bar", self.db.UI.OptionsFrame)
	statusbar:SetPoint("BOTTOMLEFT", self.db.UI.OptionsFrame, "BOTTOMLEFT", 15, 15)
	statusbar:SetPoint("BOTTOMRIGHT", self.db.UI.OptionsFrame, "BOTTOMRIGHT", -15, 15)
	statusbar:SetHeight(24)
	statusbar:SetBackdrop(PaneBackdrop)
	statusbar:SetBackdropColor(0.1,0.1,0.1)
	statusbar:SetBackdropBorderColor(0.4,0.4,0.4)
	
	statusbar.font = statusbar:CreateFontString("statusbar", "ARTWORK", "GameFontWhite")
	statusbar.font:SetPoint("LEFT", statusbar, "LEFT", 7, 0)
	statusbar.font:SetHeight(22)
	
	self.db.UI.StatusBar = statusbar
end

function UpgradeList:CreateItemTrackButton()
	local button = CreateFrame('Button', "ItemTrackButton", self.db.UI.OptionsFrame, "UIPanelButtonTemplate2")
	button:SetPoint("TOPRIGHT", self.db.UI.OptionsFrame, "TOPRIGHT", -50, -50)
	button:SetWidth(175)
	button:SetHeight(30)
	button:SetText("Item Search")
	button:SetScript("OnClick", function (self, button, down)
		UpgradeList:DrawItemTrackWindow()
	end)
	
	self.db.UI.ItemTrackButton = button
end

function UpgradeList:CreatePointInputFrame()
	local frame = CreateFrame("Frame", "PointInput", UIParent)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetWidth(250)
	frame:SetHeight(200)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:Hide()
	
	frame.heading = CreateFrame('Frame', "PointInputHeading", frame)
	frame.heading.font = frame.heading:CreateFontString("PointInputHeading", "ARTWORK", "GameFontNormal")
	frame.heading.font:SetText(L["Enter the number\n of points needed\n for this item:"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("TOP", frame, "TOP", 0, -15)
	frame.heading.font:SetWidth(230)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())
	
	frame.box = CreateFrame("Editbox", "PointInputBox", frame, "InputBoxTemplate")
	frame.box:SetPoint("CENTER", frame, "CENTER", 0, 0)
	frame.box:SetAutoFocus(true)
	frame.box:SetWidth(175)
	frame.box:SetHeight(27)
	frame.box:SetNumeric(1)
	frame.box:SetMaxLetters(5)
	
	frame.OK = CreateFrame('Button', "PointInputOK", frame, "UIPanelButtonTemplate")
	frame.OK:SetPoint("BOTTOM", frame, "BOTTOM", -50, 20)
	frame.OK:SetWidth(100)
	frame.OK:SetHeight(24)
	frame.OK:SetText(_G["OKAY"])
	frame.OK:SetScript("OnClick", function (self, button, down)
		local pointnum = tonumber(frame.box:GetText())
		if pointnum == nil then
			UpgradeList:StatusBarUpdate(L["No number entered."], "red")
		elseif pointnum >= 0 then
			pointnum = math.floor(pointnum)
			UIDropDownMenu_SetText(ULLocationDropDown_Button, UIDropDownMenu_GetSelectedName(ULLocationDropDown_Button))
			frame:Hide()
			frame.box:SetText("")
			UpgradeList.db.SelectedBoss = pointnum
			UpgradeList.db.SelectedInstance = UIDropDownMenu_GetSelectedName(ULLocationDropDown_Button)
			UpgradeList.db.SelectedDifficulty = ""
			UpgradeList:EnableInput()
		else
			UpgradeList:StatusBarUpdate(L["Invalid number."], "red")
		end
	end)
	
	frame.Cancel = CreateFrame('Button', "PointInputCancel", frame, "UIPanelButtonTemplate")
	frame.Cancel:SetPoint("LEFT", frame.OK, "RIGHT", 0, 0)
	frame.Cancel:SetWidth(100)
	frame.Cancel:SetHeight(24)
	frame.Cancel:SetText(_G["CANCEL"])
	frame.Cancel:SetScript("OnClick", function (self, button, down)
		UIDropDownMenu_SetText(ULLocationDropDown_Button, L["Location:"])
		frame:Hide()
		UpgradeList:EnableInput()
		frame.box:SetText("")
	end)
	
	self.db.UI.PointInput = frame
end

function UpgradeList:CreateWeaponInputFrame()
	local frame = CreateFrame("Frame", "WeaponInput", UIParent)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetWidth(250)
	frame:SetHeight(200)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:Hide()
	
	frame.heading = CreateFrame('Frame', "WeaponInputHeading", frame)
	frame.heading.font = frame.heading:CreateFontString("WeaponInputHeading", "ARTWORK", "GameFontNormal")
	frame.heading.font:SetText(L["Select which list to add this item:"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("TOP", frame, "TOP", 0, -15)
	frame.heading.font:SetWidth(230)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())
	
	--Main Hand weapon checkbox
	frame.MainHandCheck = CreateFrame('CheckButton', "MainHandCheck", frame, "UICheckButtonTemplate")
	frame.MainHandCheck:SetPoint("CENTER", frame, "CENTER", -30, 25)
	frame.MainHandCheck:SetChecked(true)
	_G[frame.MainHandCheck:GetName() .. "Text"]:SetText(_G["MAINHANDSLOT"])
	frame.MainHandCheck:SetScript("OnClick", function (self, button, down)
		frame.OffHandCheck:SetChecked(false)
		frame.MainHandCheck:SetChecked(true)
	end)
	
	--Off Hand weapon checkbox
	frame.OffHandCheck = CreateFrame('CheckButton', "OffHandCheck", frame, "UICheckButtonTemplate")
	frame.OffHandCheck:SetPoint("TOP", frame.MainHandCheck, "BOTTOM", 0, 0)
	frame.OffHandCheck:SetChecked(false)
	_G[frame.OffHandCheck:GetName() .. "Text"]:SetText(_G["SECONDARYHANDSLOT"])
	frame.OffHandCheck:SetScript("OnClick", function (self, button, down)
		frame.OffHandCheck:SetChecked(true)
		frame.MainHandCheck:SetChecked(false)
	end)
	
	frame.OK = CreateFrame('Button', "WeaponInputOK", frame, "UIPanelButtonTemplate")
	frame.OK:SetPoint("BOTTOM", frame, "BOTTOM", -50, 20)
	frame.OK:SetWidth(100)
	frame.OK:SetHeight(24)
	frame.OK:SetText(_G["OKAY"])
	frame.OK:SetScript("OnClick", function (self, button, down)
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(UpgradeList.db.UI.ItemEntryBox:GetText())
		local priorityfieldnum = tonumber(UpgradeList.db.UI.PriorityField:GetText())
		if priorityfieldnum ~= nil then
			priorityfieldnum = math.floor(priorityfieldnum)
		end
		if UpgradeList.db.UI.PrimarySpecRadioButton:GetChecked() then --Adding to Primary Spec List
			if frame.MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if UpgradeList.db.UI.PriorityField:GetText() == "" or priorityfieldnum > UpgradeList.db.char.PrimarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeList.db.char.PrimarySpecList.Main.Row[UpgradeList.db.char.PrimarySpecList.Main.Count] = { UpgradeList.db.char.PrimarySpecList.Main.Count, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() }
				elseif priorityfieldnum <= UpgradeList.db.char.PrimarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeList.db.char.PrimarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() })
					for i = UpgradeList.db.char.PrimarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeList.db.char.PrimarySpecList.Main.Row[i][1] = i
					end
				end
				UpgradeList.db.char.PrimarySpecList.Main.Count = UpgradeList.db.char.PrimarySpecList.Main.Count + 1
				UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your Primary Spec's Main tab."], "green")
				if (PanelTemplates_GetSelectedTab(UpgradeList.db.UI.MainFrame) == 13) and (UpgradeList.db.UI.ViewPrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeList.db.SelectedInstance = nil
				UpgradeList.db.SelectedBoss = nil
				UpgradeList.db.SelectedDifficulty = nil
				UpgradeList.db.UI.ItemEntryBox:SetText("")
				UpgradeList.db.UI.ItemEntryBox:ClearFocus()
				UpgradeList.db.UI.NoteEntryBox:SetText("")
				UpgradeList.db.UI.NoteEntryBox:ClearFocus()
				UpgradeList.db.UI.PriorityField:SetText("")
				UpgradeList.db.UI.PriorityField:ClearFocus()
				UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
			elseif frame.OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if UpgradeList.db.UI.PriorityField:GetText() == "" or priorityfieldnum > UpgradeList.db.char.PrimarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeList.db.char.PrimarySpecList.Off.Row[UpgradeList.db.char.PrimarySpecList.Off.Count] = { UpgradeList.db.char.PrimarySpecList.Off.Count, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() }
				elseif priorityfieldnum <= UpgradeList.db.char.PrimarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeList.db.char.PrimarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() })
					for i = UpgradeList.db.char.PrimarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeList.db.char.PrimarySpecList.Off.Row[i][1] = i
					end
				end
				UpgradeList.db.char.PrimarySpecList.Off.Count = UpgradeList.db.char.PrimarySpecList.Off.Count + 1
				UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your Primary Spec's Off tab."], "green")
				if (PanelTemplates_GetSelectedTab(UpgradeList.db.UI.MainFrame) == 14) and (UpgradeList.db.UI.ViewPrimaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeList.db.SelectedInstance = nil
				UpgradeList.db.SelectedBoss = nil
				UpgradeList.db.SelectedDifficulty = nil
				UpgradeList.db.UI.ItemEntryBox:SetText("")
				UpgradeList.db.UI.ItemEntryBox:ClearFocus()
				UpgradeList.db.UI.NoteEntryBox:SetText("")
				UpgradeList.db.UI.NoteEntryBox:ClearFocus()
				UpgradeList.db.UI.PriorityField:SetText("")
				UpgradeList.db.UI.PriorityField:ClearFocus()
				UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
			else
				--Can't tell if the user selected main hand or off hand checkbox
			end
		else --Adding to Secondary Spec List
			if frame.MainHandCheck:GetChecked() then --If the user selects the Main Hand checkbox
				if UpgradeList.db.UI.PriorityField:GetText() == "" or priorityfieldnum > UpgradeList.db.char.SecondarySpecList.Main.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeList.db.char.SecondarySpecList.Main.Row[UpgradeList.db.char.SecondarySpecList.Main.Count] = { UpgradeList.db.char.SecondarySpecList.Main.Count, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() }
				elseif priorityfieldnum <= UpgradeList.db.char.SecondarySpecList.Main.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeList.db.char.SecondarySpecList.Main.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() })
					for i = UpgradeList.db.char.SecondarySpecList.Main.Count, priorityfieldnum, -1 do
						UpgradeList.db.char.SecondarySpecList.Main.Row[i][1] = i
					end
				end
				UpgradeList.db.char.SecondarySpecList.Main.Count = UpgradeList.db.char.SecondarySpecList.Main.Count + 1
				UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your Secondary Spec's Main tab."], "green")
				if (PanelTemplates_GetSelectedTab(UpgradeList.db.UI.MainFrame) == 13) and (UpgradeList.db.UI.ViewSecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeList.db.SelectedInstance = nil
				UpgradeList.db.SelectedBoss = nil
				UpgradeList.db.SelectedDifficulty = nil
				UpgradeList.db.UI.ItemEntryBox:SetText("")
				UpgradeList.db.UI.ItemEntryBox:ClearFocus()
				UpgradeList.db.UI.NoteEntryBox:SetText("")
				UpgradeList.db.UI.NoteEntryBox:ClearFocus()
				UpgradeList.db.UI.PriorityField:SetText("")
				UpgradeList.db.UI.PriorityField:ClearFocus()
				UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
			elseif frame.OffHandCheck:GetChecked() then --If the user selects the Off Hand checkbox
				if UpgradeList.db.UI.PriorityField:GetText() == "" or priorityfieldnum > UpgradeList.db.char.SecondarySpecList.Off.Count then --Priority # entered was blank or bigger than the list of items
					UpgradeList.db.char.SecondarySpecList.Off.Row[UpgradeList.db.char.SecondarySpecList.Off.Count] = { UpgradeList.db.char.SecondarySpecList.Off.Count, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() }
				elseif priorityfieldnum <= UpgradeList.db.char.SecondarySpecList.Off.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
					table.insert(UpgradeList.db.char.SecondarySpecList.Off.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, UpgradeList.db.SelectedDifficulty, UpgradeList.db.SelectedInstance, UpgradeList.db.SelectedBoss, UpgradeList.db.UI.NoteEntryBox:GetText(), UpgradeList.db.UI.ItemEntryBox:GetText() })
					for i = UpgradeList.db.char.SecondarySpecList.Off.Count, priorityfieldnum, -1 do
						UpgradeList.db.char.SecondarySpecList.Off.Row[i][1] = i
					end
				end
				UpgradeList.db.char.SecondarySpecList.Off.Count = UpgradeList.db.char.SecondarySpecList.Off.Count + 1
				UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your Secondary Spec's Off tab."], "green")
				if (PanelTemplates_GetSelectedTab(UpgradeList.db.UI.MainFrame) == 14) and (UpgradeList.db.UI.ViewSecondaryCheck:GetChecked() == 1) then --If you're viewing the tab you're adding to
					UpgradeList:RefreshWindow()
				end
				UpgradeList.db.SelectedInstance = nil
				UpgradeList.db.SelectedBoss = nil
				UpgradeList.db.SelectedDifficulty = nil
				UpgradeList.db.UI.ItemEntryBox:SetText("")
				UpgradeList.db.UI.ItemEntryBox:ClearFocus()
				UpgradeList.db.UI.NoteEntryBox:SetText("")
				UpgradeList.db.UI.NoteEntryBox:ClearFocus()
				UpgradeList.db.UI.PriorityField:SetText("")
				UpgradeList.db.UI.PriorityField:ClearFocus()
				UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
			else
				UpgradeList:StatusBarUpdate(L["ERROR: Unable to determine if you selected Main Hand or Off Hand for this weapon"], "red")
			end
		end
		frame:Hide()
		frame.OffHandCheck:SetChecked(false)
		frame.MainHandCheck:SetChecked(true)
		UpgradeList:EnableInput()
	end)
	
	frame.Cancel = CreateFrame('Button', "WeaponInputCancel", frame, "UIPanelButtonTemplate")
	frame.Cancel:SetPoint("LEFT", frame.OK, "RIGHT", 0, 0)
	frame.Cancel:SetWidth(100)
	frame.Cancel:SetHeight(24)
	frame.Cancel:SetText(_G["CANCEL"])
	frame.Cancel:SetScript("OnClick", function (self, button, down)
		frame:Hide()
		frame.OffHandCheck:SetChecked(false)
		frame.MainHandCheck:SetChecked(true)
		UpgradeList:EnableInput()
	end)

	self.db.UI.WeaponInput = frame
end

function UpgradeList:CreateSpecInputFrame()
	local frame = CreateFrame("Frame", "SpecInput", UIParent)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetWidth(250)
	frame:SetHeight(200)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:Hide()
	
	frame.heading = CreateFrame('Frame', "SpecInputHeading", frame)
	frame.heading.font = frame.heading:CreateFontString("SpecInputHeading", "ARTWORK", "GameFontNormal")
	frame.heading.font:SetText(L["Is your newly acquired item for your Main Spec or your Off Spec?"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("TOP", frame, "TOP", 0, -15)
	frame.heading.font:SetWidth(230)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())
	
	--Main Spec selected
	frame.MainSpecCheck = CreateFrame('CheckButton', "MainSpecCheck", frame, "UICheckButtonTemplate")
	frame.MainSpecCheck:SetPoint("CENTER", frame, "CENTER", -30, 25)
	frame.MainSpecCheck:SetChecked(true)
	_G[frame.MainSpecCheck:GetName() .. "Text"]:SetText(L["Main Spec"])
	frame.MainSpecCheck:SetScript("OnClick", function (self, button, down)
		frame.OffSpecCheck:SetChecked(false)
		frame.MainSpecCheck:SetChecked(true)
	end)
	
	--Off Spec selected
	frame.OffSpecCheck = CreateFrame('CheckButton', "OffSpecCheck", frame, "UICheckButtonTemplate")
	frame.OffSpecCheck:SetPoint("TOP", frame.MainSpecCheck, "BOTTOM", 0, 0)
	frame.OffSpecCheck:SetChecked(false)
	_G[frame.OffSpecCheck:GetName() .. "Text"]:SetText(L["Off Spec"])
	frame.OffSpecCheck:SetScript("OnClick", function (self, button, down)
		frame.OffSpecCheck:SetChecked(true)
		frame.MainSpecCheck:SetChecked(false)
	end)
	
	frame.OK = CreateFrame('Button', "SpecInputOK", frame, "UIPanelButtonTemplate")
	frame.OK:SetPoint("BOTTOM", frame, "BOTTOM", -50, 20)
	frame.OK:SetWidth(100)
	frame.OK:SetHeight(24)
	frame.OK:SetText(_G["OKAY"])
		
	frame.Cancel = CreateFrame('Button', "SpecInputCancel", frame, "UIPanelButtonTemplate")
	frame.Cancel:SetPoint("LEFT", frame.OK, "RIGHT", 0, 0)
	frame.Cancel:SetWidth(100)
	frame.Cancel:SetHeight(24)
	frame.Cancel:SetText(_G["CANCEL"])
	frame.Cancel:SetScript("OnClick", function (self, button, down)
		frame:Hide()
		frame.OffSpecCheck:SetChecked(false)
		frame.MainSpecCheck:SetChecked(true)
		UpgradeList:EnableInput()
	end)
	
	self.db.UI.SpecInput = frame
end

function UpgradeList:CreateMainHandorOffHandFrame()
	local frame = CreateFrame("Frame", "MainHandorOffHand", UIParent)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetWidth(250)
	frame:SetHeight(200)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:Hide()
	
	frame.heading = CreateFrame('Frame', "MainHandorOffHandHeading", frame)
	frame.heading.font = frame.heading:CreateFontString("MainHandorOffHandHeading", "ARTWORK", "GameFontNormal")
	frame.heading.font:SetText(L["Is your newly acquired item for your Main Hand or your Off Hand?"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("TOP", frame, "TOP", 0, -15)
	frame.heading.font:SetWidth(230)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())
	
	--Main Hand weapon check
	frame.WeaponInMain = CreateFrame('CheckButton', "WeaponInMain", frame, "UICheckButtonTemplate")
	frame.WeaponInMain:SetPoint("CENTER", frame, "CENTER", -30, 25)
	frame.WeaponInMain:SetChecked(true)
	_G[frame.WeaponInMain:GetName() .. "Text"]:SetText(_G["MAINHANDSLOT"])
	frame.WeaponInMain:SetScript("OnClick", function (self, button, down)
		frame.WeaponInOff:SetChecked(false)
		frame.WeaponInMain:SetChecked(true)
	end)
	
	--Off Hand weapon check
	frame.WeaponInOff = CreateFrame('CheckButton', "WeaponInOff", frame, "UICheckButtonTemplate")
	frame.WeaponInOff:SetPoint("TOP", frame.WeaponInMain, "BOTTOM", 0, 0)
	frame.WeaponInOff:SetChecked(false)
	_G[frame.WeaponInOff:GetName() .. "Text"]:SetText(_G["SECONDARYHANDSLOT"])
	frame.WeaponInOff:SetScript("OnClick", function (self, button, down)
		frame.WeaponInOff:SetChecked(true)
		frame.WeaponInMain:SetChecked(false)
	end)
	
	frame.OK = CreateFrame('Button', "MainHandorOffHandOK", frame, "UIPanelButtonTemplate")
	frame.OK:SetPoint("BOTTOM", frame, "BOTTOM", -50, 20)
	frame.OK:SetWidth(100)
	frame.OK:SetHeight(24)
	frame.OK:SetText(_G["OKAY"])
	
	frame.Cancel = CreateFrame('Button', "MainHandorOffHandCancel", frame, "UIPanelButtonTemplate")
	frame.Cancel:SetPoint("LEFT", frame.OK, "RIGHT", 0, 0)
	frame.Cancel:SetWidth(100)
	frame.Cancel:SetHeight(24)
	frame.Cancel:SetText(_G["CANCEL"])
	frame.Cancel:SetScript("OnClick", function (self, button, down)
		frame:Hide()
		frame.WeaponInOff:SetChecked(false)
		frame.WeaponInMain:SetChecked(true)
		UpgradeList:EnableInput()
	end)
	
	self.db.UI.MainHandorOffHand = frame
end

function UpgradeList:CreateEditNoteFrame()
	local frame = CreateFrame("Frame", "EditNote", UIParent)
	frame:SetFrameStrata("FULLSCREEN")
	frame:SetWidth(360)
	frame:SetHeight(150)
	frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
		edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
		tile = true, tileSize = 32, edgeSize = 32, 
		insets = { left = 11, right = 11, top = 10, bottom = 10 }})
	frame:SetBackdropColor(0,0,0,1)
	frame:SetPoint("CENTER", UIParent, "CENTER")
	frame:Hide()
	
	frame.heading = CreateFrame('Frame', "EditNoteHeading", frame)
	frame.heading.font = frame.heading:CreateFontString("EditNoteHeading", "ARTWORK", "GameFontNormal")
	frame.heading.font:SetText(L["Enter your new note:"])
	frame.heading.font:SetJustifyH("CENTER")
	frame.heading.font:SetPoint("TOP", frame, "TOP", 0, -15)
	frame.heading.font:SetWidth(230)
	frame.heading.font:SetHeight(frame.heading.font:GetStringHeight())
	
	frame.box = CreateFrame("Editbox", "EditNoteBox", frame, "InputBoxTemplate")
	frame.box:SetPoint("CENTER", frame, "CENTER", 0, 0)
	frame.box:SetAutoFocus(true)
	frame.box:SetWidth(285)
	frame.box:SetHeight(27)
	
	frame.OK = CreateFrame('Button', "EditNoteOK", frame, "UIPanelButtonTemplate")
	frame.OK:SetPoint("BOTTOM", frame, "BOTTOM", -50, 20)
	frame.OK:SetWidth(100)
	frame.OK:SetHeight(24)
	frame.OK:SetText(_G["OKAY"])
	
	frame.Cancel = CreateFrame('Button', "EditNoteCancel", frame, "UIPanelButtonTemplate")
	frame.Cancel:SetPoint("LEFT", frame.OK, "RIGHT", 0, 0)
	frame.Cancel:SetWidth(100)
	frame.Cancel:SetHeight(24)
	frame.Cancel:SetText(_G["CANCEL"])
	frame.Cancel:SetScript("OnClick", function (self, button, down)
		frame:Hide()
		UpgradeList:EnableInput()
		frame.box:SetText("")
	end)
	
	self.db.UI.EditNote = frame
end

function UpgradeList:DrawItemTrackWindow()
	if self.db.UI.TrackFrame then
		self.db.UI.MainFrame:Hide()
		self.db.UI.TrackFrame:Show()
	else
		self.db.UI.MainFrame:Hide()
		self.db.UI.TrackFrame = {}
		self.db.UI.TrackFrame.ButtonName = {}
		
		--Main Frame
		local frame = CreateFrame('Frame', "TrackFrame", UIParent)
		frame:SetFrameStrata("DIALOG")
		frame:SetWidth(750)
		frame:SetHeight(700)
		frame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
			edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 11, right = 11, top = 10, bottom = 10 }})
		frame:SetBackdropColor(0,0,0,1)
		frame:SetPoint("CENTER", UIParent, "CENTER")
		frame:SetMovable(true)
		frame:EnableMouse(true)
		frame:RegisterForDrag("LeftButton")
		frame:SetScript("OnDragStart", frame.StartMoving)
		frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
		tinsert(UISpecialFrames, "TrackFrame")
		
		frame.title = frame:CreateTexture(nil, "ARTWORK")
		frame.title:SetTexture("Interface/DialogFrame/UI-DialogBox-Header")
		frame.title:SetWidth(300)
		frame.title:SetHeight(64)
		frame.title:SetPoint("TOP", frame, 0, 12)
		
		frame.title.text = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
		frame.title.text:SetText('Item Search')
		frame.title.text:SetPoint("TOP", frame, 0, -3)
		
		--Close Button
		frame.CloseButton = CreateFrame('Button', "CloseButton", frame, "UIPanelCloseButton")
		frame.CloseButton:SetPoint("TOPRIGHT", -1, -2)
		frame.CloseButton:SetWidth(40)
		frame.CloseButton:SetHeight(40)
		
		frame.CheckBoxHeading = CreateFrame('Frame', "CheckBoxHeading", frame)
		frame.CheckBoxHeading.font = frame.CheckBoxHeading:CreateFontString("CheckBoxHeading", "ARTWORK", "GameFontNormal")
		frame.CheckBoxHeading.font:SetText("Select Categories:")
		frame.CheckBoxHeading.font:SetJustifyH("CENTER")
		frame.CheckBoxHeading.font:SetPoint("TOP", frame, "TOP", 0, -30)
		frame.CheckBoxHeading.font:SetWidth(230)
		frame.CheckBoxHeading.font:SetHeight(frame.CheckBoxHeading.font:GetStringHeight())
		
		
		local buttonTypes = {_G["CHAT_MSG_RAID"], _G["ENCOUNTER_JOURNAL_INSTANCE"], _G["TRADE_SKILLS"], _G["QUESTS_LABEL"], _G["REPUTATION"], _G["PURCHASE"], _G["CHANNEL_CATEGORY_WORLD"], _G["OTHER"]}
		local rowCount = 1
		local itemInRow = 1
		
		frame.checkButtons = {}
		
		for i = 1, #buttonTypes, 1 do
			local name = CreateFrame('CheckButton', buttonTypes[i] .. "CheckButton", TrackFrame, "UICheckButtonTemplate")
			name:SetHeight(30)
			name:SetWidth(30)
			if itemInRow == 1 then
				name:SetPoint("TOPLEFT", TrackFrame, "TOPLEFT", 150, -30 * rowCount - 25)
			elseif itemInRow == 2 then
				name:SetPoint("TOPLEFT", TrackFrame, "TOPLEFT", 265, -30 * rowCount - 25)
			elseif itemInRow == 3 then
				name:SetPoint("TOPLEFT", TrackFrame, "TOPLEFT", 380, -30 * rowCount - 25)
			else
				name:SetPoint("TOPLEFT", TrackFrame, "TOPLEFT", 520, -30 * rowCount - 25)
			end
			itemInRow = itemInRow + 1
			if itemInRow == 5 then
				itemInRow = 1
				rowCount = rowCount + 1
			end
			_G[name:GetName() .. "Text"]:SetText(buttonTypes[i])
			name:SetScript("OnClick", function (self, button, down)
				if name:GetChecked() == 1 then
					name:SetChecked(true)
				else
					name:SetChecked(false)
				end
			end)
			frame.checkButtons[i] = name
		end
		
		local cols = {
			{  -- col 1
				name	= "Spec",
				width	= 70,
				defaultsort = "asc",
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
			{  -- col 2
				name	= _G["SLOT_ABBR"],
				width	= 70,
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
			{  -- col 3
				name	= _G["ENCOUNTER_JOURNAL_ITEM"],
				width	= 220,
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
			{  -- col 4
				name	= L["Difficulty"],
				width	= 70,
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
			{  -- col 5
				name	= _G["INSTANCE"],
				width	= 130,
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
			{  -- col 6
				name	= _G["BOSS"],
				width	= 150,
				align = "CENTER",
				bgcolor = {
					["r"] = 0.0, 
					["g"] = 0.0, 
					["b"] = 0.0, 
					["a"] = 1.0, 
				},
			},
		}
		local rows = 44
		local height = 11
		local UpgradeListSearchTable = LibStub("ScrollingTable")
		
		frame.table = UpgradeListSearchTable:CreateST(cols, rows, height, nil, frame)
		frame.table.frame:SetPoint("TOPLEFT", frame, "TOPLEFT", 8, -197)
		frame.table.frame:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -8, 8)
		frame.table:RegisterEvents({
			["OnClick"] = function (rowFrame, cellFrame, data, cols, row, realrow, column, UpgradeListSearchTable, ...)
				if realrow ~= nil then
					ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
					ItemRefTooltip:SetHyperlink(data[realrow][3])
					ShowUIPanel(ItemRefTooltip)
				end
			end,
		})
		
		frame.button = CreateFrame('Button', "SearchButton", frame, "UIPanelButtonTemplate2")
		frame.button:SetPoint("CENTER", frame, "TOP", 0, -150)
		frame.button:SetWidth(150)
		frame.button:SetHeight(25)
		frame.button:SetText(_G["SEARCH"])
		frame.button:SetScript("OnClick", function(self, button, down)
			frame.table:SetData(UpgradeList:ScanDatabase(), true)
		end)

		frame:Show()
		self.db.UI.TrackFrame = frame
	end
end

function UpgradeList:DrawUI()
	UpgradeList:LoadDropdownItems() --In ItemLocations.lua
	UpgradeList:LoadDungeonJournalInfo()
	
	--Create Scrolling Window
	UpgradeList:CreateScrollingWindow()

	--Create Main Frame
	UpgradeList:CreateMainFrame()
	
	--Create the self.db.char.SavedOptions.tableUL by defining the columns, rows, height of the rows, then creating the self.db.char.SavedOptions.tableUL
	UpgradeList:CreateScrollingItemFrame()
	
	--"Close" button
	UpgradeList:CloseButton()
	
	--"ToggleOptions" button
	UpgradeList:ToggleOptionsButton()
	
	--"PrimarySpecView" button
	UpgradeList:PrimarySpecViewButton()
	
	--"SecondarySpecView" button
	UpgradeList:SecondarySpecViewButton()
	
	--Explanation of what the various clicks on the table do
	UpgradeList:ExplanationHeadingText()

	--Create all the 16 tabs for the equipment slots
	UpgradeList:TabCreate()
	
	--Create the options frame below the main frame
	UpgradeList:CreateOptionsFrame()
	
	--Creation of the Item Entry Box
	UpgradeList:CreateItemEntryBox()
	
	--Creation of the dropdown menus
	UpgradeList:CreateDropdownMenu()
	
	--Creation of the Note Entry Box
	UpgradeList:CreateNoteEntryBox()
	
	--Primary & Secondary Spec Selector Radio Buttons
	UpgradeList:CreateSpecRadioButtons()

	--AddItemLocation
	UpgradeList:AddItemLocation()	
	
	--"Add" button
	UpgradeList:CreateAddButton()

	--Moving an item stuff
	UpgradeList:CreateMoveItem()
	
	--Deleting a single item stuff
	UpgradeList:CreateDeleteSingleItem()
	
	--Deleting many items stuff
	UpgradeList:CreateDeleteManyItems()
	
	--Status Bar
	UpgradeList:CreateStatusBar()
	
	--Item Track Button
	UpgradeList:CreateItemTrackButton()

	--Frame for entering the number of points needed for certain items
	UpgradeList:CreatePointInputFrame()
	
	--Frame for selecting whether a weapon is main hand or off hand.
	UpgradeList:CreateWeaponInputFrame()
	
	--Frame for asking whether an acquired upgrade is for Main Spec or Off Spec
	UpgradeList:CreateSpecInputFrame()
	
	--Frame for asking whether an acquired upgrade is for Main Hand or Off Hand
	UpgradeList:CreateMainHandorOffHandFrame()

	--Frame for entering a new note
	UpgradeList:CreateEditNoteFrame()
	
	self.db.UI.MainFrame:Hide()
end